/**
	First implementatios of dancing a ball inside a canvas
	ball v. 0.0

	Fraga 03/10/2000
**/
#include <qpainter.h>
#include <qobject.h>
#include <math.h>
#include "canvas.h"


Canvas::Canvas( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
    setPalette( QPalette( QColor( 250, 250, 200) ) );
    setMouseTracking( TRUE );

	ang=40.0;
	xact = yact = 0;

	time = 500;    // 900 mseg = 0.9 seg

	st = Init;
	mv = Right;
}

void Canvas::InitState ( void )
{
	ang=0.0;
}

void Canvas::mouseMoveEvent( QMouseEvent * e )
{
	QPoint c = e->pos( );

	xmouse = c.x( );
	ymouse = c.y( );
	if ( xmouse>=0 && ymouse>=0 )  emit changePos ( );
}


//
// This method puts the initial coordinates each time window is resized
//
void Canvas::resizeEvent( QResizeEvent * )
{
	w = width( );
	h = height( );

	xact = w/2;
	yact = h/2;

	xnew = xact;
	ynew = yact;

	emit changeSize ( );
}

QSizePolicy Canvas::sizePolicy() const
{
	return QSizePolicy( QSizePolicy::Expanding, QSizePolicy::Expanding );
}


void Canvas::keyPressEvent( QKeyEvent *e )
{
	switch ( e->key() ) {
		case Key_H:   // decrease velocity, increase time
			time += 20;
			if ( time > 2000 ) time = 2000;
			killTimers ( );
			startTimer( time );
			break;
		case Key_L:  // Increase velocity, decrase time
			time -= 20;
			if ( time < 20 ) time = 20;
			killTimers ( );
			startTimer( time );
			break;
		case Key_I:      // Initialice the ball movement again
			time = 500;   // 900 millisecond = 0.9 sec 
			killTimers( );
			break;
		default:
			return;
	}
	e->accept( );
}

void Canvas::timerEvent( QTimerEvent * te ) 
{
	if ( mv == Right ) {
		xnew = xact + 4;
		if ( (xnew + 20) >= w  ) {
			mv = Left; 
			xnew = xact - 4;
		}
	}
	else {
		xnew = xact - 4;
		if ( xnew <= 0 ) { 
			mv = Right; 
			xnew = xact + 4;
		}
	}
	repaint( );
}

void Canvas::paintEvent( QPaintEvent * )
{
	QPainter p(this);

	p.setPen( NoPen );
	if ( st == Init ) {
		p.setBrush( red );
		p.drawEllipse( xact, yact, 20, 20 );
	}
	else {  // st == Playing
		p.setBrush( p.backgroundColor () );
		p.drawEllipse( xact, yact, 20, 20 );

		p.setBrush( red );
		p.drawEllipse( xnew, ynew, 20, 20 );

		xact = xnew;
		yact = ynew;
	}
}
